<?php
namespace Teknisa\PLA\Modules\Mymenu\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class Mym00100BancoQuestaoController extends \Teknisa\GER\Controllers\TeknisaCrud
{
    
    protected $respostaService;
    protected $entityManager;
    
     public function __construct($crudService, $parameterBag, $entityManager) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->entityManager = $entityManager;
    }
    
    public function questaoIsExist(DTO\Request $request, DTO\Response $response)
    {
        try {
            $row = (array) $request->getRow();
            
            $conditions = array(
                array(
                    "columnName" => "DSRESPOSTA",
                    "operator" => "LIKE_I",
                    "value" => $row['DSRESPOSTA']
                ),
                array(
                    "columnName" => "NRQUESTAO",
                    "operator" => "=",
                    "value" => $row['NRQUESTAO']
                ),
                array(
                    "columnName" => "NRORG",
                    "operator" => "=",
                    "value" => $this->crudService->getEnvironment()->getNrOrg()
                )
            );
            
            $resultRespostas = $this->crudService->getFilteredDataSet('resposta', $conditions)->getRows();
            
            if (!empty($resultRespostas)) {
                throw new \Exception('Resposta já cadastrada!');
            }
        }
        catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    public function deleteQuestaoAndRespostas(DTO\Request $request, DTO\Response $response){
        $connection = $this->entityManager->getConnection();
        $row = (array) $request->getRow();
        $conditions = array(
                array(
                    "columnName" => "NRQUESTAO",
                    "operator" => "=",
                    "value" => $row['NRQUESTAO']
                ),
                array(
                    "columnName" => "NRORG",
                    "operator" => "=",
                    "value" => $this->crudService->getEnvironment()->getNrOrg()
                )
            );
            $array[]=$row;
            $resultRespostas = $this->crudService->getFilteredDataSet('resposta', $conditions)->getRows();
            $dataSetRespostas = new DataSet('resposta', $resultRespostas);
            $dataSetQuestao = new DataSet('questao', $array);
            try {
                $connection->beginTransaction();
                $this->crudService->delete($response,$dataSetRespostas);
                $this->crudService->delete($response,$dataSetQuestao);
                $connection->commit();
            } catch (\Exception $e) {
                $connection->rollBack();
                $response->setError(new Error("Erro durante o processo de exclusão de questão e respostas. ". $e->getMessage(), 500));
            }
    }
    
}